require "violence"
require "violence/helpers"
require "set"

class Violence::Agent
  attr_accessor :bank
  attr_accessor :productivity
  attr_accessor :greed
  attr_accessor :allconsumed
  attr_accessor :clepto

  include Violence::Helpers
  
  def initialize
    self.bank = 2*(powerlaw(5) + 1) # be realistic, i.e. unfair starts

    self.productivity = 1

    # Funky stuff: We want to restrict greed to [0,1], but kinda normal-distributed
    # self.greed = (2.5 + randn)/5
    self.greed = rand.round(2)

    self.allconsumed = 0

    # if self.greed < 0 || self.greed > 1
    if !(0..1).member?(self.greed) # happens ~0.27% of the time
      self.greed = 0.5 # aesthetically hideous -- don't judge me
    end
  end

  # def consume
  #   consumed = self.greed * self.produced
  #   self.bank -= consumed
  #   self.allconsumed += consumed
  # end

  def invest(cost)
    self.bank -= cost
    consumption = (rand + 1/2) * self.productivity
    self.bank -= consumption # also consume about last produced amount times greed
    self.productivity += 1

    self.allconsumed += cost + consumption
  end

  def produce
    produced = (rand + 1/2) * self.productivity
    self.bank += produced

    consumed = self.greed * produced
    self.bank -= consumed #consume

    self.allconsumed += consumed
  end

  # def consume
  #   consumption_min = 1
  #   self.resources -= consumption_min
  #   playmoney = self.consumption_want - consumption_min
  #   self.resources -= [playmoney,self.resources].min
  # end

  # def act
  #   projected_earnings = self.productivity/2
  #   if projected_earnings < self.consumption_want
  #     #learn/invest
  #     self.productivity += 0.4
  #   else
  #     earnings = 1 + rand * self.productivity
  #     self.resources += earnings
  #   end
  # end
end
